#ifndef FIND_SC_MAIN_H_INCLUDED_
#define FIND_SC_MAIN_H_INCLUDED_

#include "rose.h"

namespace risc
{

namespace traverser
{

/**
 * \brief             Checks if function is sc_main functions
 * \return            True, if it is sc_main function
 */
bool is_sc_main(const SgFunctionDeclaration* function);

/**
 * \brief             searchs for sc_main function
 * \return            Declaration of sc_main
 */
SgFunctionDeclaration* find_sc_main(SgNode* node);

}; // end namespace traverser

}; // end namespace risc

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */

#endif /* FIND_SC_MAIN_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
