#ifndef CHANNEL_H_INCLUDED_
#define CHANNEL_H_INCLUDED_

#include "class.h"

namespace risc {

class Channel: public Class {

public:

  /**
   * \brief Default constructor
   */
  explicit Channel(SgClassDefinition *ast_node, Type type);

private:

  /**
   * \brief Disabled copy constructor
   */
  Channel(const Channel &c);
};


} // end of namespace risc

#endif /* CHANNEL_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
