#include "primitive_channel_instance.h"

risc::PrimitiveChannelInstance::PrimitiveChannelInstance(
    SgVariableDefinition *ast_node, PrimitiveChannel *definition):
  ChannelInstance(ast_node, PrimitiveChannelInstanceType),
  definition_(definition)
{
}

std::string
risc::PrimitiveChannelInstance::get_ast_type_name()
{
  return get_ast_type()->unparseToString().substr(17);
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
