#include "cached_function_ast_attributes.h"

risc::sg::CachedFunctionAstAttributes::CachedFunctionAstAttributes(
    VertexDescriptor starting_vertex):
  starting_vertex_(starting_vertex)
{
}

bool
risc::sg::CachedFunctionAstAttributes::has_no_boundary()
{
  SegmentGraph::SegmentSet temp;
  temp.insert(starting_vertex_);
  return leaving_segments_ == temp;
}

bool
risc::sg::CachedFunctionAstAttributes::starting_segment_is_leaving_segment()
{
  if(leaving_segments_.find(starting_vertex_) != leaving_segments_.end()) {
    return true;
  } else {
    return false;
  }
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
