#include "systemc.h"

class InstanceConflictTableM: public sc_module {
public:

  SC_HAS_PROCESS(InstanceConflictTableM);

  InstanceConflictTableM(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {

    while(false) {

    }

    if(true) {

      wait(SC_ZERO_TIME);

    } else {

      wait(SC_ZERO_TIME);
    }

    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);
  }
};

class InstanceConflictTableA1: public sc_module {
public:

  InstanceConflictTableM m1;
  InstanceConflictTableM m2;

  InstanceConflictTableA1(sc_module_name mn):
    sc_module(mn),
    m1("m1"),
    m2("m2")
  { }
};

class InstanceConflictTableA2: public sc_module {
public:

  SC_HAS_PROCESS(InstanceConflictTableA2);

  InstanceConflictTableA2(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
  }

  void thread1()
  {
    int i;
    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);
  }
};


class InstanceConflictTableC: public sc_module {
public:

  SC_HAS_PROCESS(InstanceConflictTableC);

  InstanceConflictTableC(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
  }

  void thread1()
  {
    func();
  }

  void thread2()
  {
    func();

    func();
  }

  void func()
  {
    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);

    wait(SC_ZERO_TIME);
  }
};

class InstanceConflictTableTop: public sc_module {
public:

  InstanceConflictTableA1 a1;
  InstanceConflictTableA2 a2;
  InstanceConflictTableM m3;
  InstanceConflictTableC c;

  InstanceConflictTableTop(sc_module_name mn):
    sc_module(mn),
    a1("a1"),
    a2("a2"),
    m3("m3"),
    c("c")
  {

  }
};

#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  InstanceConflictTableTop mm("mm");

  sc_start();
  return 0;
}
#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
