#ifndef CHANNEL_INSTANCE_H_INCLUDED_
#define CHANNEL_INSTANCE_H_INCLUDED_

#include "instance.h"
#include "rose.h"

namespace risc {

class ChannelInstance: public Instance {

public:

  /**
   * \brief Default constructor
   */
  explicit ChannelInstance(SgVariableDefinition *ast_node, Type type);

private:

  /**
   * \brief Disabled copy constructor
   */
  ChannelInstance(const ChannelInstance &e);
};


}; // end namespace risc

#endif /* CHANNEL_INSTANCE_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
